diff --git a/src/tds/bulk.c b/src/tds/bulk.c
index 856f831..f549571 100644
--- a/src/tds/bulk.c
+++ b/src/tds/bulk.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: bulk.c,v 1.8 2008/12/19 18:43:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bulk.c,v 1.9 2009/01/16 20:27:58 jklowden Exp $");
 
 #ifndef MAX
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
@@ -776,7 +776,7 @@ tds_bcp_add_variable_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_d
 			padj[i] = offsets[ncols-i] >> 8;
 			poff[i] = offsets[ncols-i] & 0xFF;
 		}
-		row_pos = poff + ncols + 1 - rowbuffer;
+		row_pos = (int)(poff + ncols + 1 - rowbuffer);
 	}
 
 	tdsdump_log(TDS_DBG_FUNC, "%4d %8d %8d\n", i, ncols, row_pos);
@@ -862,8 +862,8 @@ tds7_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 		}
 		if (is_blob_type(bcpcol->on_server.column_type)) {
 			/* FIXME strlen return len in bytes not in characters required here */
-			tds_put_smallint(tds, strlen(bcpinfo->tablename));
-			tds_put_string(tds, bcpinfo->tablename, strlen(bcpinfo->tablename));
+			TDS_PUT_SMALLINT(tds, strlen(bcpinfo->tablename));
+			tds_put_string(tds, bcpinfo->tablename, (int)strlen(bcpinfo->tablename));
 		}
 		/* FIXME support multibyte string */
 		tds_put_byte(tds, bcpcol->column_namelen);
diff --git a/src/tds/challenge.c b/src/tds/challenge.c
index 2504f96..6a4c0d1 100644
--- a/src/tds/challenge.c
+++ b/src/tds/challenge.c
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: challenge.c,v 1.36 2008/11/06 14:39:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: challenge.c,v 1.37 2009/01/16 20:27:58 jklowden Exp $");
 
 /**
  * \ingroup libtds
@@ -91,16 +91,16 @@ static void tds_encrypt_answer(const unsigned char *hash, const unsigned char *c
 static void tds_convert_key(const unsigned char *key_56, DES_KEY * ks);
 
 static void
-convert_to_upper(char *buf, int len)
+convert_to_upper(char *buf, size_t len)
 {
-	int i;
+	size_t i;
 
 	for (i = 0; i < len; i++)
 		buf[i] = toupper(buf[i]);
 }
 
-static int
-convert_to_usc2le_string(TDSSOCKET * tds, const char *s, int len, char *out)
+static size_t
+convert_to_usc2le_string(TDSSOCKET * tds, const char *s, size_t len, char *out)
 {
 	const char *ib;
 	char *ob;
@@ -143,9 +143,9 @@ static int
 make_ntlm_hash(TDSSOCKET * tds, const char *passwd, unsigned char ntlm_hash[16])
 {
 	MD4_CTX context;
-	int passwd_len = 0;
+	size_t passwd_len = 0;
 	char passwd_usc2le[256];
-	int passwd_usc2le_len = 0;
+	size_t passwd_usc2le_len = 0;
 
 	passwd_len = strlen(passwd);
 
@@ -174,13 +174,13 @@ static int
 make_ntlm_v2_hash(TDSSOCKET * tds, const char *passwd, unsigned char ntlm_v2_hash[16])
 {
 	const char *user_name, *domain;
-	int domain_len, user_name_len;
+	size_t domain_len, user_name_len, len, buf_usc2le_len = 0;
 	const char *p;
 
 	unsigned char ntlm_hash[16];
 	char buf[128];
 	char buf_usc2le[512];
-	int buf_usc2le_len = 0, l, res;
+	int res;
 
 	user_name = tds_dstr_cstr(&tds->connection->user_name);
 	user_name_len = strlen(user_name);
@@ -199,19 +199,19 @@ make_ntlm_v2_hash(TDSSOCKET * tds, const char *passwd, unsigned char ntlm_v2_has
 	memcpy(buf, user_name, user_name_len);
 	convert_to_upper(buf, user_name_len);
 
-	l = convert_to_usc2le_string(tds, buf, user_name_len, buf_usc2le);
-	if (l < 0)
+	len = convert_to_usc2le_string(tds, buf, user_name_len, buf_usc2le);
+	if (len < 0)
 		return TDS_FAIL;
-	buf_usc2le_len = l;
+	buf_usc2le_len = len;
 
 	if (domain_len > 128)
 		domain_len = 128;
 	/* Target is supposed to be case-sensitive */
 
-	l = convert_to_usc2le_string(tds, domain, domain_len, buf_usc2le + l);
-	if (l < 0)
+	len = convert_to_usc2le_string(tds, domain, domain_len, buf_usc2le + len);
+	if (len < 0)
 		return TDS_FAIL;
-	buf_usc2le_len += l;
+	buf_usc2le_len += len;
 
 
 	res = make_ntlm_hash(tds, passwd, ntlm_hash);
@@ -265,8 +265,8 @@ tds_answer_challenge(TDSSOCKET * tds,
 {
 #define MAX_PW_SZ 14
 	const char *passwd = tds_dstr_cstr(&connection->password);
-	int len;
-	int i;
+	size_t len;
+	size_t i;
 	static const des_cblock magic = { 0x4B, 0x47, 0x53, 0x21, 0x40, 0x23, 0x24, 0x25 };
 	DES_KEY ks;
 	unsigned char hash[24], ntlm2_challenge[16];
@@ -402,22 +402,18 @@ tds_convert_key(const unsigned char *key_56, DES_KEY * ks)
 	memset(&key, 0, sizeof(key));
 }
 
-
 static int
 tds7_send_auth(TDSSOCKET * tds,
 	       const unsigned char *challenge, TDS_UINT flags, const unsigned char *names_blob, TDS_INT names_blob_len)
 {
-	int current_pos;
+	size_t current_pos;
 	TDSANSWER answer;
 
 	/* FIXME: stuff duplicate in tds7_send_login */
 	const char *domain;
 	const char *user_name;
 	const char *p;
-	int user_name_len;
-	int host_name_len;
-	int password_len;
-	int domain_len;
+	size_t user_name_len, host_name_len, password_len, domain_len;
 	int rc;
 
 	unsigned char *ntlm_v2_response = NULL;
@@ -465,38 +461,38 @@ tds7_send_auth(TDSSOCKET * tds,
 	/* LM/LMv2 Response */
 	tds_put_smallint(tds, lm_response_len);	/* lan man resp length */
 	tds_put_smallint(tds, lm_response_len);	/* lan man resp length */
-	tds_put_int(tds, current_pos);	/* resp offset */
+	TDS_PUT_INT(tds, current_pos);	/* resp offset */
 	current_pos += lm_response_len;
 
 	/* NTLM/NTLMv2 Response */
 	tds_put_smallint(tds, ntlm_response_len);	/* nt resp length */
 	tds_put_smallint(tds, ntlm_response_len);	/* nt resp length */
-	tds_put_int(tds, current_pos);	/* nt resp offset */
+	TDS_PUT_INT(tds, current_pos);	/* nt resp offset */
 
 	current_pos = 64;
 
 	/* Target Name - domain or server name */
-	tds_put_smallint(tds, domain_len * 2);
-	tds_put_smallint(tds, domain_len * 2);
-	tds_put_int(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, domain_len * 2);
+	TDS_PUT_SMALLINT(tds, domain_len * 2);
+	TDS_PUT_INT(tds, current_pos);
 	current_pos += domain_len * 2;
 
 	/* username */
-	tds_put_smallint(tds, user_name_len * 2);
-	tds_put_smallint(tds, user_name_len * 2);
-	tds_put_int(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, user_name_len * 2);
+	TDS_PUT_SMALLINT(tds, user_name_len * 2);
+	TDS_PUT_INT(tds, current_pos);
 	current_pos += user_name_len * 2;
 
 	/* Workstation Name */
-	tds_put_smallint(tds, host_name_len * 2);
-	tds_put_smallint(tds, host_name_len * 2);
-	tds_put_int(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, host_name_len * 2);
+	TDS_PUT_SMALLINT(tds, host_name_len * 2);
+	TDS_PUT_INT(tds, current_pos);
 	current_pos += host_name_len * 2;
 
 	/* Session Key (optional) */
 	tds_put_smallint(tds, 0);
 	tds_put_smallint(tds, 0);
-	tds_put_int(tds, current_pos + lm_response_len + ntlm_response_len);
+	TDS_PUT_INT(tds, current_pos + lm_response_len + ntlm_response_len);
 
 	/* flags */
 	/* "challenge" is 8 bytes long */
@@ -506,9 +502,9 @@ tds7_send_auth(TDSSOCKET * tds,
 	/* OS Version Structure (Optional) */
 
 	/* Data itself */
-	tds_put_string(tds, domain, domain_len);
-	tds_put_string(tds, user_name, user_name_len);
-	tds_put_string(tds, tds_dstr_cstr(&connection->client_host_name), host_name_len);
+	tds_put_string(tds, domain, (int)domain_len);
+	tds_put_string(tds, user_name, (int)user_name_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->client_host_name), (int)host_name_len);
 
 	/* data block */
 	tds_put_n(tds, answer.lm_resp, lm_response_len);
@@ -598,6 +594,7 @@ fill_names_blob_prefix(names_blob_prefix_t * prefix)
 static int
 tds_ntlm_handle_next(TDSSOCKET * tds, struct tds_authentication * auth, size_t len)
 {
+	const int length = (int)len;
 	unsigned char nonce[8];
 	TDS_UINT flags;
 	int where;
@@ -633,7 +630,7 @@ tds_ntlm_handle_next(TDSSOCKET * tds, struct tds_authentication * auth, size_t l
 	/*data_block_offset == 32 */
 	/* Version 1 -- The Context, Target Information, and OS Version structure are all omitted */
 
-	if (data_block_offset >= 48 && where + 16 <= len) {
+	if (data_block_offset >= 48 && where + 16 <= length) {
 		/* Version 2 -- The Context and Target Information fields are present, but the OS Version structure is not. */
 		tds_get_n(tds, NULL, 8);	/* Context (two consecutive longs) */
 
@@ -643,7 +640,7 @@ tds_ntlm_handle_next(TDSSOCKET * tds, struct tds_authentication * auth, size_t l
 
 		where += 16;
 
-		if (data_block_offset >= 56 && where + 8 <= len) {
+		if (data_block_offset >= 56 && where + 8 <= length) {
 			/* Version 3 -- The Context, Target Information, and OS Version structure are all present. */
 			tds_get_n(tds, NULL, 8);	/* OS Version Structure */
 			where += 8;
@@ -651,7 +648,7 @@ tds_ntlm_handle_next(TDSSOCKET * tds, struct tds_authentication * auth, size_t l
 	}
 
 	/* read Target Info if possible */
-	if (target_info_len > 0 && target_info_offset >= where && target_info_offset + target_info_len <= len) {
+	if (target_info_len > 0 && target_info_offset >= where && target_info_offset + target_info_len <= length) {
 		tds_get_n(tds, NULL, target_info_offset - where);
 		where = target_info_offset;
 
@@ -677,7 +674,7 @@ tds_ntlm_handle_next(TDSSOCKET * tds, struct tds_authentication * auth, size_t l
 		names_blob_len = 0;
 	}
 	/* discard anything left */
-	tds_get_n(tds, NULL, len - where);
+	tds_get_n(tds, NULL, length - where);
 	tdsdump_log(TDS_DBG_INFO1, "Draining %d bytes\n", (int) (len - where));
 
 	rc = tds7_send_auth(tds, nonce, flags, names_blob, names_blob_len);
@@ -708,14 +705,14 @@ tds_ntlm_get_auth(TDSSOCKET * tds)
 		return NULL;
 
 	user_name = tds_dstr_cstr(&tds->connection->user_name);
-	host_name_len = tds_dstr_len(&tds->connection->client_host_name);
+	host_name_len = (int)tds_dstr_len(&tds->connection->client_host_name);
 
 	/* check override of domain */
 	if ((p = strchr(user_name, '\\')) == NULL)
 		return NULL;
 
 	domain = user_name;
-	domain_len = p - user_name;
+	domain_len = (int)(p - user_name);
 
 	auth = (struct tds_ntlm_auth *) calloc(1, sizeof(struct tds_ntlm_auth));
 
diff --git a/src/tds/config.c b/src/tds/config.c
index 2cb061c..b361510 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.140 2008/12/17 11:12:02 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.141 2009/01/16 20:27:58 jklowden Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -286,7 +286,7 @@ tds_get_home_file(const char *file)
 	home = tds_get_homedir();
 	if (!home)
 		return NULL;
-	if (asprintf(&path, "%s" TDS_SDIR_SEPARATOR "%s", home, file) < 0)
+	if (asprintf(&path, "%s/%s", home, file) < 0)
 		path = NULL;
 	free(home);
 	return path;
diff --git a/src/tds/convert.c b/src/tds/convert.c
index a9694c5..5810975 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.186 2009/01/03 15:26:09 jklowden Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.187 2009/01/16 20:27:58 jklowden Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -156,7 +156,7 @@ string_to_result(int desttype, const char *s, CONV_RESULT * cr)
 	} else {
 		memcpy(cr->cc.c, s, len < cr->cc.len ? len : cr->cc.len);
 	}
-	return len;
+	return (TDS_INT)len;
 }
 
 #define string_to_result(s, cr) \
@@ -175,7 +175,7 @@ binary_to_result(int desttype, const void *data, size_t len, CONV_RESULT * cr)
 	} else {
 		memcpy(cr->cb.ib, data, len < cr->cb.len ? len : cr->cb.len);
 	}
-	return len;
+	return (TDS_INT)len;
 }
 
 #define binary_to_result(data, len, cr) \
@@ -206,7 +206,7 @@ tds_convert_binary(int srctype, const TDS_UCHAR * src, TDS_INT srclen, int destt
 	switch (desttype) {
 	case TDS_CONVERT_CHAR:
 		cplen = srclen * 2;
-		if (cplen > cr->cc.len)
+		if ((TDS_UINT)cplen > cr->cc.len)
 			cplen = cr->cc.len;
 
 		c = cr->cc.c;
@@ -402,7 +402,7 @@ tds_convert_char(int srctype, const TDS_CHAR * src, TDS_UINT srclen, int desttyp
 	case SYBREAL:
 		/* FIXME not null terminated */
 		/* TODO check syntax and overflow */
-		cr->r = atof(src);
+		cr->r = (TDS_REAL)atof(src);
 		return sizeof(TDS_REAL);
 		break;
 	case SYBBIT:
@@ -1517,7 +1517,7 @@ tds_convert_flt8(int srctype, const TDS_CHAR * src, int desttype, CONV_RESULT *
 		break;
 	case SYBREAL:
 		/* TODO check overflow */
-		cr->r = the_value;
+		cr->r = (TDS_REAL)the_value;
 		return sizeof(TDS_REAL);
 		break;
 	case SYBFLT8:
diff --git a/src/tds/getmac.c b/src/tds/getmac.c
index 44c2631..86bedd1 100644
--- a/src/tds/getmac.c
+++ b/src/tds/getmac.c
@@ -44,7 +44,7 @@
 
 /* TODO get real MAC */
 void
-tds_getmac(int s, unsigned char mac[6])
+tds_getmac(TDS_SYS_SOCKET s, unsigned char mac[6])
 {
 /* implementation for Linux */
 #ifdef __linux__
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index 89d1656..18fe7ce 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.135 2008/10/17 08:39:16 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.136 2009/01/16 20:27:58 jklowden Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -59,7 +59,7 @@ TDS_RCSID(var, "$Id: iconv.c,v 1.135 2008/10/17 08:39:16 freddy77 Exp $");
 static int bytes_per_char(TDS_ENCODING * charset);
 #endif
 static const char *collate2charset(int sql_collate, int lcid);
-static int skip_one_input_sequence(iconv_t cd, const TDS_ENCODING * charset, const char **input, size_t * input_size);
+static size_t skip_one_input_sequence(iconv_t cd, const TDS_ENCODING * charset, const char **input, size_t * input_size);
 static int tds_iconv_info_init(TDSICONV * char_conv, const char *client_name, const char *server_name);
 static int tds_iconv_init(void);
 static int tds_canonical_charset(const char *charset_name);
@@ -624,7 +624,7 @@ tds_iconv(TDSSOCKET * tds, const TDSICONV * conv, TDS_ICONV_DIRECTION io,
 	ICONV_CONST char *pquest_mark = quest_mark;
 	size_t lquest_mark;
 	size_t irreversible;
-	char one_character;
+	size_t one_character;
 	char *p;
 	int eilseq_raised = 0;
 	/* cast away const-ness */
@@ -1080,7 +1080,7 @@ bytes_per_char(TDS_ENCODING * charset)
  * \returns number of bytes to skip.
  */
 /* FIXME possible buffer reading overflow ?? */
-static int
+static size_t
 skip_one_input_sequence(iconv_t cd, const TDS_ENCODING * charset, const char **input, size_t * input_size)
 {
 	int charsize = CHARSIZE(charset);
diff --git a/src/tds/log.c b/src/tds/log.c
index 4beb990..7b814e4 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,7 +66,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.10 2008/12/15 05:31:15 jklowden Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.11 2009/01/16 20:27:58 jklowden Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
@@ -277,10 +277,9 @@ tdsdump_start(FILE *file, const char *fname, int line)
  * \param length   number of bytes in the buffer
  */
 void
-tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, const void *buf, int length)
+tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, const void *buf, size_t length)
 {
-	int i;
-	int j;
+	size_t i, j;
 #define BYTES_PER_LINE 16
 	const unsigned char *data = (const unsigned char *) buf;
 	const int debug_lvl = level_line & 15;
diff --git a/src/tds/login.c b/src/tds/login.c
index 81be9db..6b1ed45 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.179 2008/12/20 06:01:21 jklowden Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.180 2009/01/16 20:27:58 jklowden Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -506,7 +506,13 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 static int
 tds_put_login_string(TDSSOCKET * tds, const char *buf, int n)
 {
-	int buf_len = (buf ? strlen(buf) : 0);
+	char string[32];
+	const int buf_len = buf ? (int)strlen(buf) : 0;
+	memset(string, '<', sizeof(string));
+	memcpy(string, buf, n);
+	string[sizeof(string)-1] = '\0';
+	if(n)
+		tdsdump_dump_buf(TDS_DBG_INFO1, "login string", buf, n);
 
 	return tds_put_buf(tds, (const unsigned char *) buf, n, buf_len);
 }
@@ -616,7 +622,7 @@ tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	if (IS_TDS42(tds)) {
 		tds_put_login_string(tds, tds_dstr_cstr(&connection->password), 255);
 	} else {
-		len = tds_dstr_len(&connection->password);
+		len = (int)tds_dstr_len(&connection->password);
 		if (len > 253)
 			len = 0;
 		tds_put_byte(tds, 0);
@@ -713,20 +719,21 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	char unicode_string[256];
 	char *punicode;
 	size_t unicode_left;
-	int packet_size;
-	int block_size;
-	int current_pos;
+	size_t packet_size;
+	TDS_INT block_size;
+	size_t current_pos;
 
 	const char *user_name = tds_dstr_cstr(&connection->user_name);
-	int user_name_len = strlen(user_name);
-	int host_name_len = tds_dstr_len(&connection->client_host_name);
-	int app_name_len = tds_dstr_len(&connection->app_name);
+	// FIXME: These are defined as size_t, but should be TDS_SMALLINT. 
+	size_t user_name_len = strlen(user_name);
+	size_t host_name_len = tds_dstr_len(&connection->client_host_name);
+	size_t app_name_len = tds_dstr_len(&connection->app_name);
 	size_t password_len = tds_dstr_len(&connection->password);
-	int server_name_len = tds_dstr_len(&connection->server_name);
-	int library_len = tds_dstr_len(&connection->library);
-	int language_len = tds_dstr_len(&connection->language);
-	int database_len = tds_dstr_len(&connection->database);
-	int auth_len = 0;
+	size_t server_name_len = tds_dstr_len(&connection->server_name);
+	size_t library_len = tds_dstr_len(&connection->library);
+	size_t language_len = tds_dstr_len(&connection->language);
+	size_t database_len = tds_dstr_len(&connection->database);
+	size_t auth_len = 0;
 
 	tds->out_flag = TDS7_LOGIN;
 
@@ -768,7 +775,7 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	tdsdump_log(TDS_DBG_INFO2, "quietly sending TDS 7+ login packet\n");
 	tdsdump_off();
 
-	tds_put_int(tds, packet_size);
+	TDS_PUT_INT(tds, packet_size);
 	if (IS_TDS90(tds)) {
 		tds_put_n(tds, tds9Version, 4);
 	} else if (IS_TDS8_PLUS(tds)) {
@@ -810,8 +817,8 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	tds_put_n(tds, collation, 4);
 
 	/* host name */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, host_name_len);
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, host_name_len);
 	current_pos += host_name_len * 2;
 	if (tds->authentication) {
 		tds_put_smallint(tds, 0);
@@ -820,36 +827,36 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		tds_put_smallint(tds, 0);
 	} else {
 		/* username */
-		tds_put_smallint(tds, current_pos);
-		tds_put_smallint(tds, user_name_len);
+		TDS_PUT_SMALLINT(tds, current_pos);
+		TDS_PUT_SMALLINT(tds, user_name_len);
 		current_pos += user_name_len * 2;
 		/* password */
-		tds_put_smallint(tds, current_pos);
-		tds_put_smallint(tds, password_len);
+		TDS_PUT_SMALLINT(tds, current_pos);
+		TDS_PUT_SMALLINT(tds, password_len);
 		current_pos += password_len * 2;
 	}
 	/* app name */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, app_name_len);
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, app_name_len);
 	current_pos += app_name_len * 2;
 	/* server name */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, server_name_len);
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, server_name_len);
 	current_pos += server_name_len * 2;
 	/* unknown */
 	tds_put_smallint(tds, 0);
 	tds_put_smallint(tds, 0);
 	/* library name */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, library_len);
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, library_len);
 	current_pos += library_len * 2;
 	/* language  - kostya@warmcat.excom.spb.su */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, language_len);
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, language_len);
 	current_pos += language_len * 2;
 	/* database name */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, database_len);
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, database_len);
 	current_pos += database_len * 2;
 
 	/* MAC address */
@@ -857,27 +864,27 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	tds_put_n(tds, hwaddr, 6);
 
 	/* authentication stuff */
-	tds_put_smallint(tds, current_pos);
-	tds_put_smallint(tds, auth_len);	/* this matches numbers at end of packet */
+	TDS_PUT_SMALLINT(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, auth_len);	/* this matches numbers at end of packet */
 	current_pos += auth_len;
 
 	/* unknown */
-	tds_put_smallint(tds, current_pos);
+	TDS_PUT_SMALLINT(tds, current_pos);
 	tds_put_smallint(tds, 0);
 
 	if (IS_TDS90(tds)) {
-		tds_put_smallint(tds, current_pos);
+		TDS_PUT_SMALLINT(tds, current_pos);
 		tds_put_smallint(tds, 0);
 
 		tds_put_int(tds, 0);
 	}
 
 	/* FIXME here we assume single byte, do not use *2 to compute bytes, convert before !!! */
-	tds_put_string(tds, tds_dstr_cstr(&connection->client_host_name), host_name_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->client_host_name), (int)host_name_len);
 	if (!tds->authentication) {
 		const char *p;
 		TDSICONV *char_conv = tds->char_convs[client2ucs2];
-		tds_put_string(tds, tds_dstr_cstr(&connection->user_name), user_name_len);
+		tds_put_string(tds, tds_dstr_cstr(&connection->user_name), (int)user_name_len);
 		p = tds_dstr_cstr(&connection->password);
 		punicode = unicode_string;
 		unicode_left = sizeof(unicode_string);
@@ -892,11 +899,11 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		tds7_crypt_pass((unsigned char *) unicode_string, password_len, (unsigned char *) unicode_string);
 		tds_put_n(tds, unicode_string, password_len);
 	}
-	tds_put_string(tds, tds_dstr_cstr(&connection->app_name), app_name_len);
-	tds_put_string(tds, tds_dstr_cstr(&connection->server_name), server_name_len);
-	tds_put_string(tds, tds_dstr_cstr(&connection->library), library_len);
-	tds_put_string(tds, tds_dstr_cstr(&connection->language), language_len);
-	tds_put_string(tds, tds_dstr_cstr(&connection->database), database_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->app_name), (int)app_name_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->server_name), (int)server_name_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->library), (int)library_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->language), (int)language_len);
+	tds_put_string(tds, tds_dstr_cstr(&connection->database), (int)database_len);
 
 	if (tds->authentication)
 		tds_put_n(tds, tds->authentication->packet, auth_len);
@@ -913,9 +920,9 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
  * 'len' characters
  */
 unsigned char *
-tds7_crypt_pass(const unsigned char *clear_pass, int len, unsigned char *crypt_pass)
+tds7_crypt_pass(const unsigned char *clear_pass, size_t len, unsigned char *crypt_pass)
 {
-	int i;
+	size_t i;
 
 	for (i = 0; i < len; i++)
 		crypt_pass[i] = ((clear_pass[i] << 4) | (clear_pass[i] >> 4)) ^ 0xA5;
diff --git a/src/tds/md4.c b/src/tds/md4.c
index 1d891d3..6b570d9 100644
--- a/src/tds/md4.c
+++ b/src/tds/md4.c
@@ -42,7 +42,7 @@
 #include "tds.h"
 #include "md4.h"
 
-TDS_RCSID(var, "$Id: md4.c,v 1.7 2005/07/07 13:06:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: md4.c,v 1.8 2009/01/16 20:27:58 jklowden Exp $");
 
 #undef word32
 #define word32 TDS_UINT
@@ -92,7 +92,7 @@ MD4Init(struct MD4Context *ctx)
  * of bytes.
  */
 void
-MD4Update(struct MD4Context *ctx, unsigned char const *buf, unsigned len)
+MD4Update(struct MD4Context *ctx, unsigned char const *buf, size_t len)
 {
 	register word32 t;
 
@@ -101,7 +101,7 @@ MD4Update(struct MD4Context *ctx, unsigned char const *buf, unsigned len)
 	t = ctx->bits[0];
 	if ((ctx->bits[0] = t + ((word32) len << 3)) < t)
 		ctx->bits[1]++;	/* Carry from low to high */
-	ctx->bits[1] += len >> 29;
+	ctx->bits[1] += (TDS_UINT)len >> 29;
 
 	t = (t >> 3) & 0x3f;	/* Bytes already in shsInfo->data */
 
diff --git a/src/tds/md5.c b/src/tds/md5.c
index 5e7a012..3195baa 100644
--- a/src/tds/md5.c
+++ b/src/tds/md5.c
@@ -29,7 +29,7 @@
 #include "tds.h"
 #include "md5.h"
 
-TDS_RCSID(var, "$Id: md5.c,v 1.2 2005/07/07 13:06:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: md5.c,v 1.3 2009/01/16 20:27:58 jklowden Exp $");
 
 #undef word32
 #define word32 TDS_UINT
@@ -73,7 +73,7 @@ void MD5Init(struct MD5Context *ctx)
  * Update context to reflect the concatenation of another buffer full
  * of bytes.
  */
-void MD5Update(struct MD5Context *ctx, unsigned char const *buf, unsigned len)
+void MD5Update(struct MD5Context *ctx, unsigned char const *buf, size_t len)
 {
     register word32 t;
 
@@ -82,7 +82,7 @@ void MD5Update(struct MD5Context *ctx, unsigned char const *buf, unsigned len)
     t = ctx->bits[0];
     if ((ctx->bits[0] = t + ((word32) len << 3)) < t)
 	ctx->bits[1]++;		/* Carry from low to high */
-    ctx->bits[1] += len >> 29;
+    ctx->bits[1] += (TDS_UINT)len >> 29;
 
     t = (t >> 3) & 0x3f;	/* Bytes already in shsInfo->data */
 
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 730f70d..2c027a1 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.184 2008/12/20 19:16:31 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.185 2009/01/16 20:27:58 jklowden Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -613,6 +613,31 @@ tds_free_all_results(TDSSOCKET * tds)
 	tds->has_status = 0;
 	tds->ret_status = 0;
 }
+/*
+ * Return 1 if winsock is initialized, else 0.
+ */
+static int
+winsock_initialized()
+{
+#if defined(_WIN32) || defined(_WIN64)
+	WSADATA wsa_data;
+	int erc;
+	DWORD how_much = 0;
+	WORD requested_version = MAKEWORD(2, 2);
+	 
+	if (SOCKET_ERROR != WSAEnumProtocols(NULL, NULL, &how_much)) 
+		return 1;
+
+	if (WSANOTINITIALISED != WSAGetLastError()) 
+		return 0;
+	
+	if (SOCKET_ERROR == (erc = WSAStartup(requested_version, &wsa_data))) {
+		fprintf(stderr, "tds_init_winsock: WSAStartup failed with %d(%s)\n", erc, WSAGetLastError() ); 
+		return 0;
+	}
+#endif
+	return 1;
+}
 
 TDSCONTEXT *
 tds_alloc_context(void * parent)
@@ -620,12 +645,13 @@ tds_alloc_context(void * parent)
 	TDSCONTEXT *context;
 	TDSLOCALE *locale;
 
-	locale = tds_get_locale();
-	if (!locale)
+	if (!winsock_initialized())
+		return NULL;
+
+	if ((locale = tds_get_locale()) == NULL)
 		return NULL;
 
-	context = (TDSCONTEXT *) calloc(1, sizeof(TDSCONTEXT));
-	if (!context) {
+	if ((context = calloc(1, sizeof(TDSCONTEXT))) == NULL) {
 		tds_free_locale(locale);
 		return NULL;
 	}
@@ -1037,7 +1063,7 @@ tds_alloc_socket(TDSCONTEXT * context, int bufsize)
 }
 
 TDSSOCKET *
-tds_realloc_socket(TDSSOCKET * tds, int bufsize)
+tds_realloc_socket(TDSSOCKET * tds, size_t bufsize)
 {
 	unsigned char *new_out_buf;
 
@@ -1049,7 +1075,7 @@ tds_realloc_socket(TDSSOCKET * tds, int bufsize)
 	if (tds->out_pos <= bufsize && bufsize > 0 && 
 	    (new_out_buf = (unsigned char *) realloc(tds->out_buf, bufsize + TDS_ADDITIONAL_SPACE)) != NULL) {
 		tds->out_buf = new_out_buf;
-		tds->env.block_size = bufsize;
+		tds->env.block_size = (int)bufsize;
 		return tds;
 	}
 	return NULL;
diff --git a/src/tds/net.c b/src/tds/net.c
index 1a35c6e..7b5a63a 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -103,7 +103,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.84 2008/12/22 15:33:55 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.85 2009/01/16 20:27:58 jklowden Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL)
@@ -416,8 +416,8 @@ tds_select(TDSSOCKET * tds, unsigned tds_sel, int timeout_seconds)
 		if (exceptfds)
 			FD_SET(tds->s, exceptfds);
 
-		rc = select(tds->s + 1, readfds, writefds, exceptfds, ptv); 
-#endif
+		rc = select((int)tds->s + 1, readfds, writefds, exceptfds, ptv); 
+#endif /* USE_POLL */
 
 		if (rc > 0 ) {
 			return rc;
@@ -603,7 +603,7 @@ tds_read_packet(TDSSOCKET * tds)
 	/*
 	 * If this packet size is the largest we have gotten allocate space for it
 	 */
-	if (len > tds->in_buf_max) {
+	if ((unsigned int)len > tds->in_buf_max) {
 		unsigned char *p;
 
 		if (!tds->in_buf) {
@@ -881,7 +881,7 @@ tds7_get_instance_ports(FILE *output, const char *ip_addr)
 		selecttimeout.tv_sec = 1;
 		selecttimeout.tv_usec = 0;
 		
-		retval = select(s + 1, &fds, NULL, NULL, &selecttimeout);
+		retval = select((int)s + 1, &fds, NULL, NULL, &selecttimeout);
 #endif
 		
 		/* on interrupt ignore */
@@ -1031,7 +1031,7 @@ tds7_get_instance_port(const char *ip_addr, const char *instance)
 		/* send the request */
 		msg[0] = 4;
 		tds_strlcpy(msg + 1, instance, sizeof(msg) - 1);
-		sendto(s, msg, strlen(msg) + 1, 0, (struct sockaddr *) &sin, sizeof(sin));
+		sendto(s, msg, (int)strlen(msg) + 1, 0, (struct sockaddr *) &sin, sizeof(sin));
 
 #if USE_POLL
 		fd.fd = s;
@@ -1045,7 +1045,7 @@ tds7_get_instance_port(const char *ip_addr, const char *instance)
 		selecttimeout.tv_sec = 1;
 		selecttimeout.tv_usec = 0;
 		
-		retval = select(s + 1, &fds, NULL, NULL, &selecttimeout);
+		retval = select((int)s + 1, &fds, NULL, NULL, &selecttimeout);
 #endif
 		
 		/* on interrupt ignore */
diff --git a/src/tds/numeric.c b/src/tds/numeric.c
index 0c20c76..148a0a8 100644
--- a/src/tds/numeric.c
+++ b/src/tds/numeric.c
@@ -37,7 +37,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: numeric.c,v 1.44 2008/08/18 13:31:28 freddy77 Exp $");
+TDS_RCSID(var, "$Id: numeric.c,v 1.45 2009/01/16 20:27:58 jklowden Exp $");
 
 /* 
  * these routines use arrays of unsigned char to handle arbitrary
@@ -323,7 +323,7 @@ tds_numeric_to_string(const TDS_NUMERIC * numeric, char *s)
 	}
 
 	/* transform to 10 base number and output */
-	i = 4 * ((packet10k + TDS_VECTOR_SIZE(packet10k)) - p);	/* current digit */
+	i = 4 * (unsigned int)((packet10k + TDS_VECTOR_SIZE(packet10k)) - p);	/* current digit */
 	/* skip leading zeroes */
 	n = 1000;
 	remainder = *p;
@@ -371,21 +371,20 @@ tds_numeric_to_string(const TDS_NUMERIC * numeric, char *s)
 static int
 tds_packet_check_overflow(TDS_WORD *packet, unsigned int packet_len, unsigned int prec)
 {
-	unsigned int i;
-	int l, stop;
+	unsigned int i, len, stop;
 	const TDS_WORD *limit = &limits[limit_indexes[prec] + LIMIT_INDEXES_ADJUST * prec];
-	l = limit_indexes[prec+1] - limit_indexes[prec] + LIMIT_INDEXES_ADJUST;
+	len = limit_indexes[prec+1] - limit_indexes[prec] + LIMIT_INDEXES_ADJUST;
 	stop = prec / (sizeof(TDS_WORD) * 8);
 	/*
 	 * Now a number is
 	 * ... P[3] P[2] P[1] P[0]
 	 * while upper limit + 1 is
- 	 * zeroes limit[0 .. l-1] 0[0 .. stop-1]
+ 	 * zeroes limit[0 .. len-1] 0[0 .. stop-1]
 	 * we must assure that number < upper limit + 1
 	 */
-	if (packet_len >= l + stop) {
+	if (packet_len >= len + stop) {
 		/* higher packets must be zero */
-		for (i = packet_len; --i >= l + stop; )
+		for (i = packet_len; --i >= len + stop; )
 			if (packet[i] > 0)
 				return TDS_CONVERT_OVERFLOW;
 		/* test limit */
